<template>
  <div class="card" id="explanation_component">
    <div class="wrapper">
      <div class="title">{{ explanationTitle }}</div>
      <div class="subtitle">{{ explanationSubtitle }}</div>
      <Textblock v-bind:text="explanationText" />
    </div>
    <div class="row">
      <button
        id="btn_back"
        type="button"
        disabled
        @click="showPreviousExplanation()"
      >
        ZURÜCK
      </button>
      <button
        id="btn_next"
        type="button"
        disabled
        @click="showNextExplanation()"
      >
        WEITER
      </button>
    </div>
  </div>
</template>

<script>
import Textblock from "./basic/Textblock.vue";

export default {
  name: "Explanation",
  components: {
    Textblock,
  },
  props: {
    json_object_explanations: Object,
    reset_explanation_index: Boolean,
    reset_algorithm_started: Boolean,
    selected_network: String,
  },
  data: function () {
    return {
      explanationTitle: "",
      explanationText: "",
      explanationSubtitle: "",
      current_explanation_index: -1,
      algorithmStarted: false,
    };
  },
  watch: {
    reset_explanation_index: function () {
      this.current_explanation_index = 0;
      this.updateExplanationText();
    },
    json_object_explanations: function () {
      if (this.json_object_explanations == null) {
        this.explanationText = "";
        this.explanationTitle = "";
        this.explanationSubtitle = "";
      }
      this.current_explanation_index = 0;
      this.updateExplanationText();
    },
    reset_algorithm_started: function () {
      this.algorithmStarted = false;
    },
  },
  mounted: function () {
    if (this.selected_network != "no-selection") {
      document.getElementById("btn_next").disabled = false;
    }
    else {
      document.getElementById("btn_next").disabled = true;
    }
  },
  methods: {
    updateExplanationText() {
      if (this.json_object_explanations['error'] == undefined) {
        this.explanationText =
          this.json_object_explanations["explanations"][
            this.current_explanation_index
          ];
        this.explanationSubtitle =
          this.json_object_explanations["subtitles"][
            this.current_explanation_index
          ];
        this.explanationTitle = this.json_object_explanations["title"];
      }
    },
    setButtonDisabled(buttonId, disabled) {
      var button;
      if (buttonId == "next") {
        button = document.getElementById("btn_next");
      } else if (buttonId == "back") {
        button = document.getElementById("btn_back");
      }
      button.disabled = disabled;
    },
    showNextExplanation() {
      if (this.selected_network != "no-selection") {
        if (
          this.json_object_explanations != null &&
          this.current_explanation_index <
            this.json_object_explanations.explanations.length - 1
        ) {
          if (this.current_explanation_index == 0) {
            this.setButtonDisabled("back", false);
            this.$emit("left_first_explanation_page", "");
            if (!this.algorithmStarted) {
              this.$emit("start_algorithm", "");
              console.log("start algorithm");
              this.algorithmStarted = true;
            }
          }
        }
        this.current_explanation_index++;

        this.updateExplanationText();

        //second last explanation (= evaluation with predicted network)
        if (
          this.current_explanation_index ==
          this.json_object_explanations.explanations.length - 2
        ) {
          this.$emit("display_resut_network", true);
        }
        //last explanation (= evaluation with roc-curve)
        else if (
          this.current_explanation_index ==
          this.json_object_explanations.explanations.length - 1
        ) {
          this.setButtonDisabled("next", true);
          this.$emit("display_roc", true);
        }
      } else {
        alert("Bitte wähle noch ein Netzwerk aus.");
      }
    },
    showPreviousExplanation() {
      if (
        this.current_explanation_index > 0 &&
        this.json_object_explanations != null
      ) {
        if (this.current_explanation_index == 1) {
          //start explanation will be shown
          this.$emit("entered_first_explanation_page", "");
          this.setButtonDisabled("back", true);
        } else if (
          //last explanation (= evaluation with roc-curve) is shown
          this.current_explanation_index ==
          this.json_object_explanations.explanations.length - 1
        ) {
          this.setButtonDisabled("next"), false;
          this.$emit("display_roc", false);
        } else if (
          //second last explanation (= evaluation with predicted network) is shown
          this.current_explanation_index ==
          this.json_object_explanations.explanations.length - 2
        ) {
          this.$emit("display_resut_network", false);
        }

        this.current_explanation_index--;
        this.updateExplanationText();
      }
    },
  },
};
</script>

<style scoped>
.row {
  display: flex;
  justify-content: flex-start;
  margin-top: 10px;
  height: 100px;
}

#explanation_component {
  height: 700px;
  min-height: 700px;
  max-height: 700px;
  margin: 5px;
}

.wrapper {
  min-height: 100%;
  height: auto !important;
  height: 100%;
  margin: 0 0 -100px 0;
  max-height: 600px;
}
</style>
